<?php
    require "DB.php";

# ------------------------------------------------------------------------------

function sdb_add_page($database, $position, $add_around, $add_name, &$error) {

    # Connect to database.
    $dsn = "mysql://calpep_page_w:calpep_page_w@localhost/$database";

    $connection = DB::connect($dsn, true);

    if (DB::isError($connection)) {
        $error = $connection->getMessage();
        return E_USER_ERROR;
    }

    # Get the id of the page where are inserting around.
    $_sql = "SELECT id FROM survey WHERE title = \"$add_around\"";

    $result = $connection->query($_sql);
    if (DB::isError($result)) {
        $error = $result->getMessage();
        $connection->disconnect();
        return E_USER_ERROR;
    }

    $id = 1;
    while ($row = $result->fetchRow(DB_FETCHMODE_ASSOC)) {
        $id = $row["id"];
    }

    $add_pos = 0;
    if ($position == "before") {
        $add_pos = $id;
    } else if ($position == "after") {
        $add_pos = $id + 1;
    } else {
        $error = "Illegal position";
        $connection->disconnect();
        return E_USER_ERROR;
    }

    $_sql = "UPDATE survey SET id=id+1 WHERE id>=$add_pos ORDER BY id DESC";
    $result = $connection->query($_sql);
    if (DB::isError($result)) {
        $error = $result->getMessage();
        $connection->disconnect();
        return E_USER_ERROR;
    }


    $_sql = "INSERT INTO survey (id, title) VALUES ($add_pos, \"$add_name\")";
    $result = $connection->query($_sql);
    if (DB::isError($result)) {
        $error = $result->getMessage();
        $connection->disconnect();
        return E_USER_ERROR;
    }

    $connection->disconnect();

    return 0;
}

# ------------------------------------------------------------------------------

function sdb_delete_page($database, $title, &$error) {

    # Connect to database.
    $dsn = "mysql://calpep_page_w:calpep_page_w@localhost/$database";

    $connection = DB::connect($dsn, true);

    if (DB::isError($connection)) {
        $error = $connection->getMessage();
        return E_USER_ERROR;
    }

    # Get the id of the page being deleted.
    $_sql = "SELECT id FROM survey WHERE title = \"$title\"";

    $result = $connection->query($_sql);
    if (DB::isError($result)) {
        $error = $result->getMessage();
        $connection->disconnect();
        return E_USER_ERROR;
    }

    $id = 1;
    while ($row = $result->fetchRow(DB_FETCHMODE_ASSOC)) {
        $id = $row["id"];
    }

    $_sql = "DELETE FROM survey WHERE title = \"$title\"";

    $result = $connection->query($_sql);
    if (DB::isError($result)) {
        $error = $result->getMessage();
        $connection->disconnect();
        return E_USER_ERROR;
    }

    $_sql = "UPDATE survey SET id=id-1 WHERE id>$id ORDER BY id ASC";

    $result = $connection->query($_sql);
    if (DB::isError($result)) {
        $error = $result->getMessage();
        $connection->disconnect();
        return E_USER_ERROR;
    }

    $connection->disconnect();

    return 0;
}

# ------------------------------------------------------------------------------

function sdb_move_page($database, $move_page, $move_position, $move_around, &$error) {

    # Fetch the id of this page.
    $result = sdb_fetch_page_id($database, $move_page, $page_id, $error);
    if ($result != 0) {
        return $result;
    }

    $title = null;
    $text = null;
    $control = null;
    $dontknow = null;
    $refuse = null;
    $na = null;
    $prev = null;
    $next  = null;
    $repeat = null;
    $choice1 = null;
    $choice2 = null;
    $choice3 = null;
    $choice4  = null;
    $choice5 = null;
    $choice6 = null;
    $choice7  = null;
    $choice8 = null;
    $choice9 = null;
    $choice10 = null;
    $choice11 = null;
    $choice12 = null;
    $choicecount = null;
    $yes_redirect = null;
    $no_redirect = null;
    $choice1_redirect = null;
    $choice2_redirect = null;
    $choice3_redirect = null;
    $choice4_redirect = null;
    $choice5_redirect = null;
    $choice6_redirect = null;
    $choice7_redirect = null;
    $choice8_redirect = null;
    $choice9_redirect = null;
    $choice10_redirect = null;
    $choice11_redirect = null;
    $choice12_redirect = null;

    $result = sdb_fetch_page($database, $page_id, $title, $text, $control, $dontknow, $refuse, $na, $prev, $next, 
                        $repeat, $choice1, $choice2, $choice3, $choice4, $choice5, $choice6, $choice7, 
                        $choice8, $choice9, $choice10, $choice11, $choice12, $choicecount,
                        $yes_redirect, $no_redirect,
                        $choice1_redirect, $choice2_redirect, $choice3_redirect, $choice4_redirect,
                        $choice5_redirect, $choice6_redirect, $choice7_redirect, $choice8_redirect,
                        $choice9_redirect, $choice10_redirect, $choice11_redirect, $choice12_redirect,
                        $error);
    if ($result != 0) {
        return $result;
    }

    $result = sdb_delete_page($database, $title, $error);
    if ($result != 0) {
        return $result;
    }

    $result = sdb_add_page($database, $move_position, $move_around, $title, $error);
    if ($result != 0) {
        return $result;
    }

    # Fetch the id of the page again because it has moved.
    $result = sdb_fetch_page_id($database, $move_page, $page_id, $error);
    if ($result != 0) {
        return $result;
    }

    $result = sdb_update_page($database, $page_id, $title, $text, $control, $dontknow, $refuse, $na, $prev, $next, 
                              $repeat, $choice1, $choice2, $choice3, $choice4, $choice5, $choice6, $choice7, 
                              $choice8, $choice9, $choice10, $choice11, $choice12, $choicecount, $yes_redirect,
                              $no_redirect,
                              $choice1_redirect, $choice2_redirect, $choice3_redirect, $choice4_redirect,
                              $choice5_redirect, $choice6_redirect, $choice7_redirect, $choice8_redirect,
                              $choice9_redirect, $choice10_redirect, $choice11_redirect, $choice12_redirect,
                              $error);
    if ($result != 0) {
        return $result;
    }

    return 0;
    
}

# ------------------------------------------------------------------------------

function sdb_fetch_page_id($database, $title, &$page_id, &$error) {

    # Connect to database.
    $dsn = "mysql://calpep_page_r:calpep_page_r@localhost/$database";

    $connection = DB::connect($dsn, true);

    if (DB::isError($connection)) {
        $error = $connection->getMessage();
        return E_USER_ERROR;
    }

    # Get the id of the page.
    $_sql = "SELECT id FROM survey WHERE title = \"$title\"";

    $result = $connection->query($_sql);
    if (DB::isError($result)) {
        $error = $result->getMessage();
        $connection->disconnect();
        return E_USER_ERROR;
    }

    $page_id = 1;
    while ($row = $result->fetchRow(DB_FETCHMODE_ASSOC)) {
        $page_id = $row["id"];
    }

    $connection->disconnect();

    return 0;
}

# ------------------------------------------------------------------------------

function sdb_fetch_page($database, $page_id, &$title, &$text, &$control, &$dontknow, &$refuse, &$na, &$prev, &$next, 
                        &$repeat, &$choice1, &$choice2, &$choice3, &$choice4, &$choice5, &$choice6, &$choice7, 
                        &$choice8, &$choice9, &$choice10, &$choice11, &$choice12, &$choicecount,
                        &$yes_redirect, &$no_redirect, 
                        &$choice1_redirect, &$choice2_redirect, &$choice3_redirect, &$choice4_redirect,
                        &$choice5_redirect, &$choice6_redirect, &$choice7_redirect, &$choice8_redirect,
                        &$choice9_redirect, &$choice10_redirect, &$choice11_redirect, &$choice12_redirect,
                        &$error) {

    # Connect to database.
    $dsn = "mysql://calpep_page_r:calpep_page_r@localhost/$database";

    $connection = DB::connect($dsn, true);

    if (DB::isError($connection)) {
        $error = $connection->getMessage();
        #TODO: MAKE THIS A GETCODE CALL.
        return E_USER_ERROR;
    }

    $_sql = "SELECT text,
                    title,
                    control_type,
                    button_dontknow_enabled,
                    button_refuse_enabled,
                    button_na_enabled,
                    button_prev_enabled,
                    button_next_enabled,
                    button_repeat_enabled,
                    choice1,
                    choice2,
                    choice3,
                    choice4,
                    choice5,
                    choice6,
                    choice7,
                    choice8,
                    choice9,
                    choice10,
                    choice11,
                    choice12,
                    choicecount,
                    choice1_redirect,
                    choice2_redirect,
                    choice3_redirect,
                    choice4_redirect,
                    choice5_redirect,
                    choice6_redirect,
                    choice7_redirect,
                    choice8_redirect,
                    choice9_redirect,
                    choice10_redirect,
                    choice11_redirect,
                    choice12_redirect,
                    yes_redirect,
                    no_redirect
                    FROM survey WHERE id = $page_id";

    $result = $connection->query($_sql);
    if (DB::isError($result)) {
        $error = $result->getMessage();
        $connection->disconnect();
        return E_USER_ERROR;
    }

    while ($row = $result->fetchRow(DB_FETCHMODE_ASSOC)) {
        $text = $row["text"];
        $title = $row["title"];
        $control = $row["control_type"];
        $dontknow = $row["button_dontknow_enabled"];
        $refuse = $row["button_refuse_enabled"];
        $na = $row["button_na_enabled"];
        $prev = $row["button_prev_enabled"];
        $next = $row["button_next_enabled"];
        $repeat = $row["button_repeat_enabled"];
        $choice1 = $row["choice1"];
        $choice2 = $row["choice2"];
        $choice3 = $row["choice3"];
        $choice4 = $row["choice4"];
        $choice5 = $row["choice5"];
        $choice6 = $row["choice6"];
        $choice7 = $row["choice7"];
        $choice8 = $row["choice8"];
        $choice9 = $row["choice9"];
        $choice10 = $row["choice10"];
        $choice11 = $row["choice11"];
        $choice12 = $row["choice12"];
        $choicecount = $row["choicecount"];
        $yes_redirect = $row["yes_redirect"];
        $no_redirect = $row["no_redirect"];
        $choice1_redirect = $row["choice1_redirect"];
        $choice2_redirect = $row["choice2_redirect"];
        $choice3_redirect = $row["choice3_redirect"];
        $choice4_redirect = $row["choice4_redirect"];
        $choice5_redirect = $row["choice5_redirect"];
        $choice6_redirect = $row["choice6_redirect"];
        $choice7_redirect = $row["choice7_redirect"];
        $choice8_redirect = $row["choice8_redirect"];
        $choice9_redirect = $row["choice9_redirect"];
        $choice10_redirect = $row["choice10_redirect"];
        $choice11_redirect = $row["choice11_redirect"];
        $choice12_redirect = $row["choice12_redirect"];
    }

    $connection->disconnect();

    return 0;
}

# ------------------------------------------------------------------------------
function sdb_fetch_pages($database, &$pages, &$error) {

    # Connect to database.
    $dsn = "mysql://calpep_page_r:calpep_page_r@localhost/$database";

    $connection = DB::connect($dsn, true);

    if (DB::isError($connection)) {
        $error = $connection->getMessage();
        return E_USER_ERROR;
    }

    $_sql = "SELECT * FROM survey ORDER BY id";

    $result = $connection->query($_sql);
    if (DB::isError($result)) {
        $error = $result->getMessage();
        $connection->disconnect();
        return E_USER_ERROR;
    }

    while ($row = $result->fetchRow(DB_FETCHMODE_ASSOC)) {
        $pages[$row["id"]] = $row["title"];
    }

    $connection->disconnect();

    return 0;
}

# ------------------------------------------------------------------------------

function sdb_update_page($database, $page_id, $title, $text, $control, $dontknow, $refuse, $na, $prev, $next, $repeat,
                         $choice1, $choice2, $choice3, $choice4, $choice5, $choice6, $choice7, $choice8,
                         $choice9, $choice10, $choice11, $choice12, $choicecount, $yes_redirect,
                         $no_redirect, 
                         $choice1_redirect, $choice2_redirect, $choice3_redirect, $choice4_redirect,
                         $choice5_redirect, $choice6_redirect, $choice7_redirect, $choice8_redirect,
                         $choice9_redirect, $choice10_redirect, $choice11_redirect, $choice12_redirect,
                         &$error) {

    $fields = array();

    # Connect to database.
    $dsn = "mysql://calpep_page_w:calpep_page_w@localhost/$database";

    $connection = DB::connect($dsn, true);

    if (DB::isError($connection)) {
        $error = $connection->getMessage();
        return E_USER_ERROR;
    }

    if (isset($text)) {
        $fields['text'] = "'$text'";
    }
    if (isset($title)) {
        $fields['title'] = "'$title'";
    }
    if (isset($control)) {
        $fields['control_type'] = "'$control'";
    }
    if (isset($dontknow)) {
        $fields['button_dontknow_enabled'] = $dontknow;
    }
    if (isset($refuse)) {
        $fields['button_refuse_enabled'] = $refuse;
    }
    if (isset($na)) {
        $fields['button_na_enabled'] = $na;
    }
    if (isset($prev)) {
        $fields['button_prev_enabled'] = $prev;
    }
    if (isset($next)) {
        $fields['button_next_enabled'] = $next;
    }
    if (isset($repeat)) {
        $fields['button_repeat_enabled'] = $repeat;
    }
    if (isset($choice1)) {
        $fields['choice1'] = "'$choice1'";
    }
    if (isset($choice2)) {
        $fields['choice2'] = "'$choice2'";
    }
    if (isset($choice3)) {
        $fields['choice3'] = "'$choice3'";
    }
    if (isset($choice4)) {
        $fields['choice4'] = "'$choice4'";
    }
    if (isset($choice5)) {
        $fields['choice5'] = "'$choice5'";
    }
    if (isset($choice6)) {
        $fields['choice6'] = "'$choice6'";
    }
    if (isset($choice7)) {
        $fields['choice7'] = "'$choice7'";
    }
    if (isset($choice8)) {
        $fields['choice8'] = "'$choice8'";
    }
    if (isset($choice9)) {
        $fields['choice9'] = "'$choice9'";
    }
    if (isset($choice10)) {
        $fields['choice10'] = "'$choice10'";
    }
    if (isset($choice11)) {
        $fields['choice11'] = "'$choice11'";
    }
    if (isset($choice12)) {
        $fields['choice12'] = "'$choice12'";
    }
    if (isset($choicecount)) {
        $fields['choicecount'] = "'$choicecount'";
    }
    if (isset($yes_redirect)) {
        $fields['yes_redirect'] = "'$yes_redirect'";
    }
    if (isset($no_redirect)) {
        $fields['no_redirect'] = "'$no_redirect'";
    }
    if (isset($choice1_redirect)) {
        $fields['choice1_redirect'] = "'$choice1_redirect'";
    }
    if (isset($choice2_redirect)) {
        $fields['choice2_redirect'] = "'$choice2_redirect'";
    }
    if (isset($choice3_redirect)) {
        $fields['choice3_redirect'] = "'$choice3_redirect'";
    }
    if (isset($choice4_redirect)) {
        $fields['choice4_redirect'] = "'$choice4_redirect'";
    }
    if (isset($choice5_redirect)) {
        $fields['choice5_redirect'] = "'$choice5_redirect'";
    }
    if (isset($choice6_redirect)) {
        $fields['choice6_redirect'] = "'$choice6_redirect'";
    }
    if (isset($choice7_redirect)) {
        $fields['choice7_redirect'] = "'$choice7_redirect'";
    }
    if (isset($choice8_redirect)) {
        $fields['choice8_redirect'] = "'$choice8_redirect'";
    }
    if (isset($choice9_redirect)) {
        $fields['choice9_redirect'] = "'$choice9_redirect'";
    }
    if (isset($choice10_redirect)) {
        $fields['choice10_redirect'] = "'$choice10_redirect'";
    }
    if (isset($choice11_redirect)) {
        $fields['choice11_redirect'] = "'$choice11_redirect'";
    }
    if (isset($choice12_redirect)) {
        $fields['choice12_redirect'] = "'$choice12_redirect'";
    }

    $_sql = "UPDATE survey SET ";

    $first = 1;
    foreach ($fields as $key => $value) {
        if ($first == 0) {
            $_sql .= ", ";
        } else {
            $first = 0;
        }


        $_sql .= "$key = $value";
    }

    $_sql .= " WHERE id = $page_id";

    $result = $connection->query($_sql);
    if (DB::isError($result)) {
        $error = $result->getMessage();
        $connection->disconnect();
        return E_USER_ERROR;
    }

    $connection->disconnect();

    return 0;
}

# ------------------------------------------------------------------------------

function sdb_is_title_unique($database, $page_id, $title) {

    # Connect to database.
    $dsn = "mysql://calpep_page_r:calpep_page_r@localhost/$database";

    $connection = DB::connect($dsn, true);

    if (DB::isError($connection)) {
        $error = $connection->getMessage();
        return E_USER_ERROR;
    }

    if ($page_id != null) {
        $_sql = "SELECT * FROM survey WHERE id != $page_id AND title = \"$title\"";
    } else {
        $_sql = "SELECT * FROM survey WHERE title = \"$title\"";
    }

    $result = $connection->query($_sql);
    if (DB::isError($result)) {
        $error = $result->getMessage();
        $connection->disconnect();
        return E_USER_ERROR;
    }

    if ($result->numRows() > 0) {
        $connection->disconnect();
        return false;
    } else {
        $connection->disconnect();
        return true;
    }
}

# ------------------------------------------------------------------------------

function sdb_verify_user($user_id, &$error) {

    # Connect to database.
    $dsn = "mysql://calpep_user_r:calpep_user_r@localhost/users";

    $connection = DB::connect($dsn, true);
    if (DB::isError($connection)) {
        $error = $connection->getMessage();
        return E_USER_ERROR;
    }

    $_sql = "SELECT * from u$user_id";

    $result = $connection->query($_sql);
    if (DB::isError($result)) {

       if ($result->getCode() == DB_ERROR_NOSUCHTABLE) {

            $write_dsn = "mysql://calpep_user_w:calpep_user_w@localhost/users";

            $write_connection = DB::connect($write_dsn, true);
            if (DB::isError($write_connection)) {
                $error = $write_connection->getMessage();
                $connection->disconnect();
                return E_USER_ERROR;
            }

            # Create table for new user.
            $_sql = "CREATE TABLE u$user_id (page_id int(16), title BLOB, response BLOB, response_ids BLOB, PRIMARY KEY (page_id))";


            $result = $write_connection->query($_sql);
            if (DB::isError($result)) {
                $error = $result->getMessage();
                $connection->disconnect();
                return E_USER_ERROR;
            }

            $write_connection->disconnect();
       } else {
            $error = $result->getMessage();
            $connection->disconnect();
            return E_USER_ERROR;
       }
    }

    $connection->disconnect();

    return 0;
}

# ------------------------------------------------------------------------------

function sdb_update_user($user_id, $page_id, $title, $response, $response_ids, &$error) {

    # Connect to database.
    $dsn = "mysql://calpep_user_w:calpep_user_w@localhost/users";

    $connection = DB::connect($dsn, true);

    if (DB::isError($connection)) {
        $error = $connection->getMessage();
        return E_USER_ERROR;
    }

    # Check if there is already an entry for this page.
    $_sql = "SELECT * from u$user_id WHERE page_id = $page_id";

    $result = $connection->query($_sql);
    if (DB::isError($result)) {
        $error = $result->getMessage();
        $connection->disconnect();
        return $result->getCode();
    }

    if ($result->numRows() > 0) {
        # Update entry.
        $_sql = "UPDATE u$user_id SET title=\"$title\", response=\"$response\", response_ids=\"$response_ids\" WHERE page_id = $page_id";
    } else {
        # Create new entry.
        $_sql = "INSERT INTO u$user_id (page_id, title, response, response_ids) VALUES ($page_id, \"$title\", \"$response\", \"$response_ids\")";
    }

    $result = $connection->query($_sql);
    if (DB::isError($result)) {
        $error = $result->getMessage();
        $connection->disconnect();
        return $result->getCode();
    }

    $connection->disconnect();

    return 0;
}

# ------------------------------------------------------------------------------
function sdb_fetch_response($user_id, $page_title, &$response, &$response_ids, &$error) {

    $ids_str = "";

    # Connect to database.
    $dsn = "mysql://calpep_user_r:calpep_user_r@localhost/users";

    $connection = DB::connect($dsn, true);
    if (DB::isError($connection)) {
        $error = $connection->getMessage();
        return E_USER_ERROR;
    }

    $_sql = "SELECT * from u$user_id";

    $result = $connection->query($_sql);
    if (DB::isError($result)) {

       if ($result->getCode() == DB_ERROR_NOSUCHTABLE) {
            # User hasn't been recorded yet, no response ids available.
            $connection->disconnect();
            return 0;
       } else {
            $error = $result->getMessage();
            $connection->disconnect();
            return E_USER_ERROR;
       }
    }

    $_sql = "SELECT * FROM u$user_id WHERE title = \"$page_title\"";

    $result = $connection->query($_sql);
    if (DB::isError($result)) {
        $error = $result->getMessage();
        $connection->disconnect();
        return $result->getCode();
    }

    if ($result->numRows() > 0) {
        while ($row = $result->fetchRow(DB_FETCHMODE_ASSOC)) {
            $ids_str = $row['response_ids'];
            $response = $row['response'];
        }

        $response_ids = explode(",", $ids_str);
    }

    $connection->disconnect();

    return 0;
}

# ------------------------------------------------------------------------------

function fetch_all_user_data(&$data, &$error) {

    # Connect to database.
    $dsn = "mysql://calpep_user_r:calpep_user_r@localhost/users";

    $connection = DB::connect($dsn, true);
    if (DB::isError($connection)) {
        $error = $connection->getMessage();
        return E_USER_ERROR;
    }

    $_sql = "SHOW TABLES;";

    $result = $connection->query($_sql);
    if (DB::isError($result)) {
        $error = $result->getMessage();
        $connection->disconnect();
        return $result->getCode();
    }

    while ($row = $result->fetchRow(DB_FETCHMODE_ASSOC)) {

        $table = $row["Tables_in_users"];

        $_sql = "SELECT * FROM $table ORDER BY page_id";

        $tables_result = $connection->query($_sql);
        if (DB::isError($result)) {
            $error = $tables_result->getMessage();
            $connection->disconnect();
            return $tables_result->getCode();
        }

        while ($row = $tables_result->fetchRow(DB_FETCHMODE_ASSOC)) {
            $data .= $table;
            $data .= "\t";
            $data .= $row["page_id"];
            $data .= "\t";
            $data .= str_replace("\r\n", "", $row["response"]);
            $data .= "\r\n";
        }
    }

    $connection->disconnect();

    return 0;
}

?>
