<?php
    # POST Inputs:
    #   page_id    =>  Id of the page being edited.  Default is 1.
    #   user_id    =>  Id of the user being surveyed.  Required.
    #   ref_id     =>  Id of the refering page.
    #   ref_title  =>  Title of the referring page.
    #   response   =>  Response from the previous question.
    #   navigation =>  Navigation from the previous question.
    #   useredit   =>  The value of the user edit field, if one is present.  This is used
    #                  to retain the users entry when an alternate key entry is loaded.

    $_key =  '';
    $_value =  '';
    $_post = "";
    foreach($_POST as $_key => $_value) {
        $_post .= $_key . ' => "' . $_value . "\"\n";
    }
    unset($_key);
    unset($_value);

?>
<!--
<pre>
<?php echo($_post); ?>
</pre>
-->
<?php
    require "sdb.php";

    $_user_id = 0;
    $_title = "";
    $_text = '';
    $_control = '';
    $_navigation = "";
    $_useredit = "";
    $_yes_redirect = "NONE";
    $_no_redirect = "NONE";
    $_response_ids = array();
    $_response = "";
    $_buttons = array( "dontknow" => 0,
                       "refuse"   => 0,
                       "na"       => 0,
                       "prev"     => 0,
                       "next"     => 0,
                       "repeat"   => 0);

    $_choices = array( "choice1" => "",
                       "choice2" => "",
                       "choice3" => "",
                       "choice4" => "",
                       "choice5" => "",
                       "choice6" => "",
                       "choice7" => "",
                       "choice8" => "",
                       "choice9" => "",
                       "choice10" => "",
                       "choice11" => "",
                       "choice12" => "");

    $_choice_redirects = array( "choice1" => "NONE",
                                "choice2" => "NONE",
                                "choice3" => "NONE",
                                "choice4" => "NONE",
                                "choice5" => "NONE",
                                "choice6" => "NONE",
                                "choice7" => "NONE",
                                "choice8" => "NONE",
                                "choice9" => "NONE",
                                "choice10" => "NONE",
                                "choice11" => "NONE",
                                "choice12" => "NONE" );
    $_key = '';
    $_value = '';

    if (isset($_POST['response'])) {

        $response_ids = "";
        if (isset($_POST['response_ids'])) {
            $response_ids = $_POST['response_ids'];
        }

        if (!isset($_POST['ref_id'])) {
            trigger_error("Ref ID required to record response", E_USER_ERROR);
            exit;
        }
        if (!isset($_POST['ref_title'])) {
            trigger_error("Ref title required to record response", E_USER_ERROR);
            exit;
        }
        if (!isset($_POST['user_id'])) {
            trigger_error("User ID required to record response", E_USER_ERROR);
            exit;
        }


        # Verify that the user exists.  This will create a table if there isn't already one.
        $_result = sdb_verify_user($_POST['user_id'], $_error);
        if ($_result != 0) {
            trigger_error($_error, $_result);
            exit;
        }
        
        # Update user.
        $_result = sdb_update_user($_POST['user_id'], $_POST['ref_id'], $_POST['ref_title'], $_POST['response'], $response_ids, $_error);
        if ($_result != 0) {
            trigger_error($_error, $_result);
            exit;
        }

        unset($response_ids);
    }

    $_page_id = 1;
    $_next_page_id = 1;
    $_prev_page_id = 1;
    if (isset($_POST['page_id'])) {
        $_page_id = $_POST['page_id'];
        unset($_POST['page_id']);
    }
    $_next_page_id = $_page_id + 1; # TODO: puts responsibility on survey designer.
    $_prev_page_id = $_page_id - 1; # TODO: puts responsibility on survey designer.

    if ((!isset($_POST['user_id']) || ($_POST['user_id'] == ""))) {
        trigger_error("User ID required", E_USER_ERROR);
        return false;
    }
    $_user_id = $_POST['user_id'];
    unset($_POST['user_id']);

    # Fetch page data.
    $_result = sdb_fetch_page("practice", $_page_id, $_title, $_text, $_control, $_buttons['dontknow'], 
                                  $_buttons['refuse'], $_buttons['na'], $_buttons['prev'], 
                                  $_buttons['next'], $_buttons['repeat'], $_choices['choice1'], 
                                  $_choices['choice2'], $_choices['choice3'], $_choices['choice4'], 
                                  $_choices['choice5'], $_choices['choice6'], $_choices['choice7'], 
                                  $_choices['choice8'], $_choices['choice9'], $_choices['choice10'], 
                                  $_choices['choice11'], $_choices['choice12'], $_choicecount,
                                  $_yes_redirect, $_no_redirect, 
                                  $_choice_redirects['choice1'], $_choice_redirects['choice2'],
                                  $_choice_redirects['choice3'], $_choice_redirects['choice4'],
                                  $_choice_redirects['choice5'], $_choice_redirects['choice6'],
                                  $_choice_redirects['choice7'], $_choice_redirects['choice8'],
                                  $_choice_redirects['choice9'], $_choice_redirects['choice10'],
                                  $_choice_redirects['choice11'], $_choice_redirects['choice12'],
                                  $_error);
    if ($_result != 0) {
        trigger_error($_error, $_result);
    }

    if ($_yes_redirect != "NONE") {
        $_result = sdb_fetch_page_id("practice", $_yes_redirect, $_id, $_error);
        if ($_result != 0) {
            trigger_error($_error, $_result);
            return false;
        }
        $_yes_redirect = $_id;
    }
    if ($_no_redirect != "NONE") {
        $_result = sdb_fetch_page_id("practice", $_no_redirect, $_id, $_error);
        if ($_result != 0) {
            trigger_error($_error, $_result);
            return false;
        }
        $_no_redirect = $_id;
    }
    foreach($_choice_redirects as $_key => $_value) {
        if ($_value != "NONE") {
            $_result = sdb_fetch_page_id("practice", $_value, $_id, $_error);
            if ($_result != 0) {
                trigger_error($_error, $_result);
                return false;
            }
            $_choice_redirects[$_key] = $_id;
        }
    }
    unset($_id);

    # Fetch stored response.
    if ($_user_id != "test") {
        $_result = sdb_fetch_response($_user_id, $_title, $_response, $_response_ids, $_error);
        if ($_result != 0) {
            trigger_error($_error, $_result);
            return false;
        }

        if (isset($_POST['navigation'])) {
            $_navigation = $_POST['navigation'];
            unset($_POST['navigation']);
        }

        if (isset($_POST['useredit'])) {
            $_useredit = $_POST['useredit'];
            unset($_POST['useredit']);
        }
    }

?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<HTML>
<HEAD>
<TITLE><?php echo($_title); ?></TITLE>
	<META http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
	<LINK REL=STYLESHEET HREF="style.css" TYPE="text/css">
</HEAD>

    <script type="text/javascript">
        function hov(loc,cls){
           if(loc.className) {
               loc.className=cls;
           }
        }

        function button_select(button){
            if (button.style.background == "") {
                button.style.background = "darkgrey";
            } else {
                button.style.background = "";
            }
        }

        function choice_handler(button, i, redirect) {

            response_input = document.createElement("input");
            response_input.setAttribute("type", "hidden");
            response_input.setAttribute("name", "response");
            response_input.setAttribute("value", button.value);
            document.choice_form.appendChild(response_input);

            response_ids_input = document.createElement("input");
            response_ids_input.setAttribute("type", "hidden");
            response_ids_input.setAttribute("name", "response_ids");
            response_ids_input.setAttribute("value", i);
            document.choice_form.appendChild(response_ids_input);

            if (redirect != "NONE") {
                choice_form.page_id.value = redirect;
            }

            document.choice_form.submit();
        }

        function prevnext_handler(navtype) {

            response_input = document.createElement("input");
            response_ids_input = document.createElement("input");

            // On previous and next, append suitable input response depending upon which controltype is present.
            if (document.multi_form != null) {

                var inputs = document.multi_form.getElementsByTagName("input");
                var response = "";
                var response_ids = "";
                for (var i=0; i<inputs.length; i++) {
                    // A non-default background color denotes a selection.
                    if ((inputs[i].name == "response") && (inputs[i].style.background != "")) {
                        if (response == "") {
                            response = "'" + inputs[i].value + "'";
                            response_ids = (i + 1);
                        } else {
                            response = response + ": '" + inputs[i].value + "'";
                            response_ids = response_ids + "," + (i + 1);
                        }
                    }
                }

                response_input.setAttribute("type", "hidden");
                response_input.setAttribute("name", "response");
                response_input.setAttribute("value", response);

                response_ids_input.setAttribute("type", "hidden");
                response_ids_input.setAttribute("name", "response_ids");
                response_ids_input.setAttribute("value", response_ids);

            } else if ((document.key_form != null) && (document.key_form.key_text != null) && (document.key_form.key_text.value.length > 0)) {

                response_input.setAttribute("type", "hidden");
                response_input.setAttribute("name", "response");
                response_input.setAttribute("value", document.key_form.key_text.value);

            } else if (document.date_form != null) {

                var y = document.date_form.year_input.value;
                var m = document.date_form.month_input.value;
                var d = document.date_form.day_input.value;

                response_input.setAttribute("type", "hidden");
                response_input.setAttribute("name", "response");
                response_input.setAttribute("value", m + "/" + d + "/" + y);
            }

            if (navtype == "prev") {
                document.prev_form.appendChild(response_input);
                document.prev_form.appendChild(response_ids_input);
                document.prev_form.submit();
            } else {
                document.next_form.appendChild(response_input);
                document.next_form.appendChild(response_ids_input);
                document.next_form.submit();
            }
        }

        function yes_handler(redirect) {
            // Set response.
            input = document.createElement("input");
            input.setAttribute("type", "hidden");
            input.setAttribute("name", "response");
            input.setAttribute("value", "yes");
            document.yesno_form.appendChild(input);

            input = document.createElement("input");
            input.setAttribute("type", "hidden");
            input.setAttribute("name", "response_ids");
            input.setAttribute("value", "1");
            document.yesno_form.appendChild(input);

            if (redirect != "NONE") {
                input = document.createElement("input");
                input.setAttribute("type", "hidden");
                input.setAttribute("name", "page_id");
                input.setAttribute("value", redirect);
                document.yesno_form.appendChild(input);
            }

            document.yesno_form.submit();
         }

        function no_handler(redirect) {
            // Set response.
            input = document.createElement("input");
            input.setAttribute("type", "hidden");
            input.setAttribute("name", "response");
            input.setAttribute("value", "no");
            document.yesno_form.appendChild(input);

            input = document.createElement("input");
            input.setAttribute("type", "hidden");
            input.setAttribute("name", "response_ids");
            input.setAttribute("value", "2");
            document.yesno_form.appendChild(input);

            if (redirect != "NONE") {
                input = document.createElement("input");
                input.setAttribute("type", "hidden");
                input.setAttribute("name", "page_id");
                input.setAttribute("value", redirect);
                document.yesno_form.appendChild(input);
            }

            document.yesno_form.submit();
        }


        function key_handler(key) {

            var value = document.key_form.key_text.value;

            if (key == "clear") {
                document.key_form.key_text.value = "";
            } else if (key == "back") {
                if (value.length > 0) {
                    document.key_form.key_text.value = value.substring(0, (value.length - 1));
                }
            } else if (key == "space") {
                    document.key_form.key_text.value = value + " ";
            } else if ((key == "chars") || (key == "altchars")) {
                input = document.createElement("input");
                input.setAttribute("type", "hidden");
                input.setAttribute("name", "navigation");
                input.setAttribute("value", key);
                document.key_form.appendChild(input);

                input = document.createElement("input");
                input.setAttribute("type", "hidden");
                input.setAttribute("name", "useredit");
                input.setAttribute("value", value);
                document.key_form.appendChild(input);

                document.key_form.submit();
            } else {
                document.key_form.key_text.value = value + key;
            }
        }

        function year_handler(n) {
            var low = 1880;
            var val = parseInt(document.date_form.year_input.value);

            if ((val + n) < low) {
                n = -1;
            }

            val = parseInt(document.date_form.year_input.value) + n;

            if (val < 1880) {
                return;
            }
            
            document.date_form.year_input.value = val;
        }

        function month_handler(n) {
            var low = 1;
            var hi = 12;
            var val = parseInt(document.date_form.month_input.value);

            if ((val + n) < low) {
                n = -1;
            } else if ((val + n) > hi) {
                n = 1;
            }

            val = parseInt(document.date_form.month_input.value) + n;

            if ((val < 1) || (val > 12)) {
                return;
            }
            
            document.date_form.month_input.value = val;
        }

        function day_handler(n) {
            var low = 1;
            var hi = 31;
            var val = parseInt(document.date_form.day_input.value);

            if ((val + n) < low) {
                n = -1;
            } else if ((val + n) > hi) {
                n = 1;
            }

            val = parseInt(document.date_form.day_input.value) + n;

            if ((val < 1) || (val > 31)) {
                return;
            }
            
            document.date_form.day_input.value = val;
        }

        function playMusic(nm) {
            obj = document.embeds[nm];
            if(obj.Play) obj.Play();
            return true;
        }

    </script>
<BODY>

<?php
    # Don't play audio if we are simply switching to alternate keys.
    if (($_navigation != "altchars") && ($_navigation != "chars")) {
?>
<embed name="myMusic" src="./audio/<?php echo($_title); ?>_prompt.wav" type="application/x-mplayer2"
 autostart="false" hidden="" loop="true" mastersound width="128" height="128"></embed>

<!--
<BGSOUND SRC="./audio/<?php echo($_title); ?>_prompt.wav" LOOP=0>
</NOEMBED>
<EMBED SRC="./audio/<?php echo($_title); ?>_prompt.wav" AUTOSTART="True" HIDDEN="True" LOOP="false">
-->

<?php
    }
?>

<div style="position: absolute; left: 1%; top: 1%; height: 44%; width: 85%; font-size: x-large; padding: 1%; background-color: white; border: 1px solid;">
<?php echo($_text); ?>
</div>

<div style="position: absolute; left: 88.5%; top: 0%; height: 100%; width: 11%;">
<?php
    # Draw buttons.
    $_key =  '';
    $_value =  '';
    $_top = 1;
    $_input_style = "position: absolute; left: 5%; top: 5%; width: 90%; height: 90%; font-size: 19; background-color: beige; border: 1px solid; border-color: black;";
    $_button_labels = array("dontknow" => "Don't\nKnow",
                            "refuse"   => "Refuse to\nAnswer",
                            "na"       => "Not\nApplicable",
                            "prev"     => "Previous\nQuestion",
                            "next"     => "Next\nQuestion",
                            "repeat"   => "Repeat\nthe\nQuestion");

    foreach ($_buttons as $_key => $_value) {

        switch ($_key) {
            case "na":
            case "refuse":
            case "dontknow":
            case "next":
                $next_page = $_next_page_id;
                break;
            case "prev":
                $next_page = $_prev_page_id;
                break;
            case "repeat":
                $next_page = $_page_id;
                break;
            default:
                trigger_error("page ID required", E_USER_ERROR);
                break;
        }

        if ($_value != 0) {
            echo('  <form name="' . $_key . '_form" method="POST" action="survey.php">' . "\n");
            echo('  <div style="position: absolute; top: ' . $_top . '%; height:15.5%; width: 100%;">' . "\n");
            if (($_key == "prev") || ($_key == "next")) {
                echo('    <input type="submit" name="navigation" onClick="prevnext_handler(\'' . $_key . '\')" value="' . $_button_labels[$_key] . '" style="' . $_input_style . '"/>' . "\n");
            } else if ($_key == "repeat") {
                echo('    <input type="submit" name="navigation" value="' . $_button_labels[$_key] . '" style="' . $_input_style . '"/>' . "\n");
            } else {
                echo('    <input type="submit" name="response" value="' . $_button_labels[$_key] . '" style="' . $_input_style . '"/>' . "\n");
            }
            echo('  </div>' . "\n");
            echo('  <input type="hidden" name="user_id" value="' . $_user_id . '"/>' . "\n");
            echo('  <input type="hidden" name="page_id" value="' . $next_page . '"/>' . "\n");
            echo('  <input type="hidden" name="ref_id" value="' . $_page_id . '"/>' . "\n");
            echo('  <input type="hidden" name="ref_title" value="' . $_title . '"/>' . "\n");
        } else {
            echo('  <div style="position: absolute; top: ' . $_top . '%; height:15.5%; width: 100%;">' . "\n");
            echo('  </div>' . "\n");
        }
        echo('  </form>' . "\n");

        $_top += 16.5;
    }

    unset($_top);
    unset($_key);
    unset($_value);
    unset($_button_labels);
?>
</div>




<?php
    if ($_control == "static") {
        echo('<tr>' . "\n");
        echo('  <td height="50%"></td>' . "\n");
        echo('</tr' . "\n");
    } else if ($_control == "yesno") {
        echo('  <tr>' . "\n");

?>
    <form name="yesno_form" method="POST" action="survey.php">
    <div style="position: absolute; left: 1%; top: 60%; height: 12%; width: 85%; padding: 1%;">
        <input style="position: absolute; left: 25%; top: 0%; width: 15%; height: 100%; font-size: 40;" type="image" src="<?php echo((sizeof($_response_ids) > 0 && $_response_ids[0] == 1)? "yes_selected.bmp" : "yes.bmp")  ?>" onClick="yes_handler('<?php echo($_yes_redirect)?>')" value="Yes"/>
        <input style="position: absolute; left: 60%; top: 0%; width: 15%; height: 100%; font-size: 40;" type="image" src="<?php echo((sizeof($_response_ids) > 0 && $_response_ids[0] == 2)? "no_selected.bmp" : "no.bmp") ?>" onClick="no_handler('<?php echo($_no_redirect)?>')" value="No"/>
        <input type="hidden" name="user_id" value="<?php echo($_user_id) ?>"/>
        <input type="hidden" name="page_id" value="<?php echo($_next_page_id) ?>"/>
        <input type="hidden" name="ref_id" value="<?php echo($_page_id) ?>"/>
        <input type="hidden" name="ref_title" value="<?php echo($_title) ?>"/>
    </div>
    </form>
<?php
        echo('  </tr>' . "\n");

    } else if (($_control == "choice") || ($_control == "multi")) {

?>
<form method="POST" action="survey.php" name="<?php echo($_control) ?>_form">
  <div style="position: absolute; left: 2%; top: 50%; width: 85%; height: 48%;">
<?php
        $choice_labels = array( $_choices['choice1'], $_choices['choice2'], $_choices['choice3'], 
                                $_choices['choice4'], $_choices['choice5'], $_choices['choice6'],
                                $_choices['choice7'], $_choices['choice8'], $_choices['choice9'], 
                                $_choices['choice10'], $_choices['choice11'], $_choices['choice12'] );

        $_top = 0;
        $_top_offset = 0;
        $_height = 0;
        $_col1_left = 3;
        $_col2_left = 50;
        $_on_click = "";
        $_type = "submit";

        if ($_choicecount < 2) {
            trigger_error("Illegal column count.", E_USER_ERROR);
            exit;
        } else if ($_choicecount == 2) {
            $_top = 35;
            $_top_offset = 0;
            $_height = 20;
        } else if ($_choicecount <= 4) {
            $_top = 20;
            $_top_offset = 30;
            $_height = 20;
        } else if ($_choicecount <= 6) {
            $_top = 4;
            $_top_offset = 25;
            $_height = 20;
        } else if ($_choicecount <= 8) {
            $_top = 0;
            $_top_offset = 25;
            $_height = 20;
        } else if ($_choicecount <= 10) {
            $_top = 2;
            $_top_offset = 20;
            $_height = 15;
        } else if ($_choicecount <= 12) {
            $_top = 0.5;
            $_top_offset = 17;
            $_height = 15;
        }

        for ($i= 0; $i<$_choicecount; $i++) {

            if ($_control == "multi") {
                $_on_click = ' onClick="button_select(this)" ';
            } else {
                $_on_click = ' onClick="choice_handler(this, ' . ($i + 1) . ', \'' . $_choice_redirects["choice" . ($i + 1)] . '\')"  ';
            }

            $_style_add = "";
            foreach($_response_ids as $_value) {
                if (($i + 1) == $_value) {
                    $_style_add = " background-color: darkgrey;";
                }
            }

            if ($i % 2 == 0) {
                # Evens on the left.
                echo('      <input style="position: absolute; left: ' . $_col1_left . '%; top: ' . $_top . '%; width: 45%; height: ' . $_height . '%; font-size: 20; text-align: left;' . $_style_add . '" name="response" type="button" value="' . ($i + 1) . ') ' . $choice_labels[$i] . '" ' . $_on_click . '/>' . "\n");
            } else {
                # Odds on the right.
                echo('      <input style="position: absolute; left: ' . $_col2_left . '%; top: ' . $_top . '%; width: 45%; height: ' . $_height . '%; font-size: 20; text-align: left;' . $_style_add . '" name="response" type="button" value="' . ($i + 1) . ') ' . $choice_labels[$i] . '" ' . $_on_click . '/>' . "\n");

                $_top += $_top_offset;
            }

            unset($_style_add);
        }

        unset($_top);
        unset($_top_offset);
        unset($_height);
        unset($_col1_left);
        unset($_col2_left);
        unset($_on_click);
        unset($_type);
?>
    <input type="hidden" name="user_id" value="<?php echo($_user_id) ?>"/>
    <input type="hidden" name="page_id" value="<?php echo($_next_page_id) ?>"/>
    <input type="hidden" name="ref_id" value="<?php echo($_page_id) ?>"/>
    <input type="hidden" name="ref_title" value="<?php echo($_title) ?>"/>
  </div>
</form>
<?php


    } else if ($_control == "text") {
?>
<tr>
<td>
<form name="key_form" method="POST" action="survey.php">
<?php
    $alt = "";
    if ($_navigation == "altchars") {
        $alt = "chars";
        print <<< EOF
<div class="row1keys">
  <input name="input_1" type="button" class="keybtn" onClick="key_handler('1')" value="1"/>
  <input name="input_2" type="button" class="keybtn" onClick="key_handler('2')" value="2"/>
  <input name="input_3" type="button" class="keybtn" onClick="key_handler('3')" value="3"/>
  <input name="input_4" type="button" class="keybtn" onClick="key_handler('4')" value="4"/>
  <input name="input_5" type="button" class="keybtn" onClick="key_handler('5')" value="5"/>
  <input name="input_6" type="button" class="keybtn" onClick="key_handler('6')" value="6"/>
  <input name="input_7" type="button" class="keybtn" onClick="key_handler('7')" value="7"/>
</div>
<div class="row2keys">
  <input name="input_8"         type="button" class="keybtn" onClick="key_handler('8')" value="8"/>
  <input name="input_9"         type="button" class="keybtn" onClick="key_handler('9')" value="9"/>
  <input name="input_0"         type="button" class="keybtn" onClick="key_handler('0')" value="0"/>
  <input name="input_dash"      type="button" class="keybtn" onClick="key_handler('-')" value="-"/>
  <input name="input_period"    type="button" class="keybtn" onClick="key_handler('.')" value="."/>
  <input name="input_comma"     type="button" class="keybtn" onClick="key_handler(',')" value=","/>
  <input name="input_semicolon" type="button" class="keybtn" onClick="key_handler(';')" value=";"/>
</div>
<div class="row3keys">
  <input name="input_colon"  type="button" class="keybtn" onClick="key_handler(':')" value=":"/>
  <input name="input_qmark"  type="button" class="keybtn" onClick="key_handler('?')" value="?"/>
  <input name="input_bang"   type="button" class="keybtn" onClick="key_handler('!')" value="!"/>
  <input name="input_fslash" type="button" class="keybtn" onClick="key_handler('/')" value="/"/>
  <input name="input_hyphen" type="button" class="keybtn" onClick="key_handler('\'')" value="'"/>
  <input name="input_plus"   type="button" class="keybtn" onClick="key_handler('+')" value="+"/>
  <input name="input_lparen" type="button" class="keybtn" onClick="key_handler('(')" value="("/>
</div>
<div class="row4keys">
  <input name="input_rparen"  type="button" class="keybtn" onClick="key_handler(')')" value=")"/>
  <input name="input_asterix" type="button" class="keybtn" onClick="key_handler('*')" value="*"/>
  <input name="input_percent" type="button" class="keybtn" onClick="key_handler('%')" value="%"/>
  <input name="input_dollar"  type="button" class="keybtn" onClick="key_handler('$')" value="$"/>
  <input name="input_pound"   type="button" class="keybtn" onClick="key_handler('#')" value="#"/>
  <input name="input_lbrack"  type="button" class="keybtn" onClick="key_handler('<')" value="<"/>
  <input name="input_rbrack"  type="button" class="keybtn" onClick="key_handler('>')" value=">"/>
</div>
EOF;
    } else {
        $alt = "altchars";
        print <<< EOF
<div class="row1keys">
  <input name="input_A" type="button" class="keybtn" onClick="key_handler('A')" value="A"/>
  <input name="input_B" type="button" class="keybtn" onClick="key_handler('B')" value="B"/>
  <input name="input_C" type="button" class="keybtn" onClick="key_handler('C')" value="C"/>
  <input name="input_D" type="button" class="keybtn" onClick="key_handler('D')" value="D"/>
  <input name="input_E" type="button" class="keybtn" onClick="key_handler('E')" value="E"/>
  <input name="input_F" type="button" class="keybtn" onClick="key_handler('F')" value="F"/>
  <input name="input_G" type="button" class="keybtn" onClick="key_handler('G')" value="G"/>
</div>
<div class="row2keys">
  <input name="input_H" type="button" class="keybtn" onClick="key_handler('H')" value="H"/>
  <input name="input_I" type="button" class="keybtn" onClick="key_handler('I')" value="I"/>
  <input name="input_J" type="button" class="keybtn" onClick="key_handler('J')" value="J"/>
  <input name="input_K" type="button" class="keybtn" onClick="key_handler('K')" value="K"/>
  <input name="input_L" type="button" class="keybtn" onClick="key_handler('L')" value="L"/>
  <input name="input_M" type="button" class="keybtn" onClick="key_handler('M')" value="M"/>
  <input name="input_N" type="button" class="keybtn" onClick="key_handler('N')" value="N"/>
</div>
<div class="row3keys">
  <input name="input_O" type="button" class="keybtn" onClick="key_handler('O')" value="O"/>
  <input name="input_P" type="button" class="keybtn" onClick="key_handler('P')" value="P"/>
  <input name="input_Q" type="button" class="keybtn" onClick="key_handler('Q')" value="Q"/>
  <input name="input_R" type="button" class="keybtn" onClick="key_handler('R')" value="R"/>
  <input name="input_S" type="button" class="keybtn" onClick="key_handler('S')" value="S"/>
  <input name="input_T" type="button" class="keybtn" onClick="key_handler('T')" value="T"/>
  <input name="input_U" type="button" class="keybtn" onClick="key_handler('U')" value="U"/>
</div>
<div class="row4keys">
  <input name="input_V" type="button" class="keybtn" onClick="key_handler('V')" value="V"/>
  <input name="input_W" type="button" class="keybtn" onClick="key_handler('W')" value="W"/>
  <input name="input_X" type="button" class="keybtn" onClick="key_handler('X')" value="X"/>
  <input name="input_Y" type="button" class="keybtn" onClick="key_handler('Y')" value="Y"/>
  <input name="input_Z" type="button" class="keybtn" onClick="key_handler('Z')" value="Z"/>
</div>
EOF;
    }
?>
<div class="actkeys">
  <input name="Clear" type="button" class="keyactbtn" onClick="key_handler('clear')" value="Clear"/>
  <input name="Back" type="button" class="keyactbtn" onClick="key_handler('back')" value="Back"/>
  <input name="Space" type="button" class="keyactbtn" onClick="key_handler('space')" value="Space"/>
  <input name="Alt" type="button" class="keyactbtn" onClick="key_handler('<?php echo("$alt"); ?>')" value="Alt"/>
</div>
<div class="keytext">
  <input class="keytext" type="text" name="key_text" value="<?php echo($_useredit == "" ? $_response : $_useredit); ?>">
</div>
    <input type="hidden" name="user_id" value="<?php echo("$_user_id"); ?>"/>
    <input type="hidden" name="page_id" value="<?php echo("$_page_id"); ?>"/>
    <input type="hidden" name="ref_id"  value="<?php echo("$_page_id"); ?>"/>
    <input type="hidden" name="ref_title"  value="<?php echo("$_title"); ?>"/>
</form>
</td>
</tr>

<?php

    } else if ($_control == "number") {
?>
<tr>
<td>
<form name="key_form" method="POST" action="survey.php">
<?php
    print <<< EOF
<div class="numberkeys">
  <input name="input_0" type="button" class="numberbtn" onClick="key_handler('0')" value="0"/>
  <input name="input_1" type="button" class="numberbtn" onClick="key_handler('1')" value="1"/>
  <input name="input_2" type="button" class="numberbtn" onClick="key_handler('2')" value="2"/>
  <input name="input_3" type="button" class="numberbtn" onClick="key_handler('3')" value="3"/>
  <input name="input_4" type="button" class="numberbtn" onClick="key_handler('4')" value="4"/>
  <input name="input_5" type="button" class="numberbtn" onClick="key_handler('5')" value="5"/>
  <input name="input_6" type="button" class="numberbtn" onClick="key_handler('6')" value="6"/>
  <input name="input_7" type="button" class="numberbtn" onClick="key_handler('7')" value="7"/>
  <input name="input_8" type="button" class="numberbtn" onClick="key_handler('8')" value="8"/>
  <input name="input_9" type="button" class="numberbtn" onClick="key_handler('9')" value="9"/>
</div>
EOF;
?>
<div class="numberactkeys">
  <input name="Clear" type="button" class="numberactbtn" onClick="key_handler('clear')" value="Clear"/>
  <input name="Back" type="button" class="numberactbtn" onClick="key_handler('back')" value="Back"/>
</div>
<div class="number_text">
  <input class="number_text" type="text" name="key_text" value="<?php echo($_useredit == "" ? $_response : $_useredit); ?>">
</div>
    <input type="hidden" name="user_id" value="<?php echo("$_user_id"); ?>"/>
    <input type="hidden" name="page_id" value="<?php echo("$_page_id"); ?>"/>
    <input type="hidden" name="ref_id"  value="<?php echo("$_page_id"); ?>"/>
    <input type="hidden" name="ref_title"  value="<?php echo("$_title"); ?>"/>
</form>
</td>
</tr>
<?php
    } else if ($_control == "date") {
        $_year = "2006";
        $_month = "1";
        $_day = "1";

        if ($_response != "") {
            $_parts = split('/', $_response);
            $_month = $_parts[0];
            $_day = $_parts[1];
            $_year = $_parts[2];
            unset($_parts);
        }
?>
<tr>
<td>
<form name="date_form" method="POST" action="survey.php">
    <div style="position: absolute; left: 0%; top: 53%; height: 12%; width: 85%;;">
      <label style="position: absolute; left: 2%; top: 20%; font-size: 40;">Year</label>
      <div style="position: absolute; left: 20%; top: 10%; width: 60%; height: 80%;">
        <input style="position: absolute; left: 1%; top: 0%; width: 15%; height: 100%; font-size: 40;" type="button" onClick="year_handler(-10)" value="<<"/>
        <input style="position: absolute; left: 17%; top: 0%; width: 15%; height: 100%; font-size: 40;" type="button" onClick="year_handler(-1)" value="<"/>
        <input name="year_input" style="position: absolute; left: 33%; top: 4%; width: 28%; height: 92%; font-size: 54; text-align: center;" type="text" value="<?php echo($_year) ?>">
        <input style="position: absolute; left: 62%; top: 0%; width: 15%; height: 100%; font-size: 40;" type="button" onClick="year_handler(1)" value=">"/>
        <input style="position: absolute; left: 78%; top: 0%; width: 15%; height: 100%; font-size: 40;" type="button" onClick="year_handler(10)" value=">>"/>
      </div>
    </div>
    <div style="position: absolute; left: 0%; top: 66%; height: 12%; width: 85%;">
      <label style="position: absolute; left: 2%; top: 20%; font-size: 40;">Month
      <div style="position: absolute; left: 20%; top: 10%; width: 60%; height: 80%;">
        <input style="position: absolute; left: 1%; top: 0%; width: 15%; height: 100%; font-size: 40;" type="button" onClick="month_handler(-2)" value="<<"/>
        <input style="position: absolute; left: 17%; top: 0%; width: 15%; height: 100%; font-size: 40;" type="button" onClick="month_handler(-1)" value="<"/>
        <input name="month_input" style="position: absolute; left: 33%; top: 4%; width: 28%; height: 92%; font-size: 54; text-align: center;" type="text" value="<?php echo($_month) ?>">
        <input style="position: absolute; left: 62%; top: 0%; width: 15%; height: 100%; font-size: 40;" type="button" onClick="month_handler(1)" value=">"/>
        <input style="position: absolute; left: 78%; top: 0%; width: 15%; height: 100%; font-size: 40;" type="button" onClick="month_handler(2)" value=">>"/>
      </div>
    </div>
    <div style="position: absolute; left: 0%; top: 79%; height: 12%; width: 85%;">
      <label style="position: absolute; left: 2%; top: 20%; font-size: 40;">Day
      <div style="position: absolute; left: 20%; top: 10%; width: 60%; height: 80%;">
        <input style="position: absolute; left: 1%; top: 0%; width: 15%; height: 100%; font-size: 40;" type="button" onClick="day_handler(-5)" value="<<"/>
        <input style="position: absolute; left: 17%; top: 0%; width: 15%; height: 100%; font-size: 40;" type="button" onClick="day_handler(-1)" value="<"/>
        <input name="day_input" style="position: absolute; left: 33%; top: 4%; width: 28%; height: 92%; font-size: 54; text-align: center;" type="text" value="<?php echo($_day) ?>">
        <input style="position: absolute; left: 62%; top: 0%; width: 15%; height: 100%; font-size: 40;" type="button" onClick="day_handler(1)" value=">"/>
        <input style="position: absolute; left: 78%; top: 0%; width: 15%; height: 100%; font-size: 40;" type="button" onClick="day_handler(5)" value=">>"/>
      </div>
    </div>
    <input type="hidden" name="user_id" value="<?php echo("$_user_id"); ?>"/>
    <input type="hidden" name="page_id" value="<?php echo("$_page_id"); ?>"/>
    <input type="hidden" name="ref_id"  value="<?php echo("$_page_id"); ?>"/>
    <input type="hidden" name="ref_title"  value="<?php echo("$_title"); ?>"/>
</form>
<?php
        unset($_year);
        unset($_month);
        unset($_day);
    }
?>
<!--
<pre>
<?php echo($_post); ?>
</pre>
-->

</BODY>
